
#Clean hospital names 
cleanHospitalName = function(x) {
  x = trimws(x)
  x = ifelse(substr(tolower(x), nchar(x) - 3, nchar(x)) == "hosp", paste0(substr(x, 1, nchar(x) - 4), "Hospital"), x)
  x = gsub("St Joseph's Hospital", "St Joseph's", gsub("Joe's", "Joseph's", gsub("St.", "St", x, fixed = TRUE), fixed = TRUE), fixed = TRUE)
  x = gsub("Joesph", "Joseph", x)
  x = gsub("harleson", "harleston", gsub("Joseph's - B", "Joseph's (B)", gsub("Joseph's - P", "Joseph's (P)", x, fixed = TRUE), fixed = TRUE))
  x = ifelse(gsub(" ", "", tolower(x)) %in% c("beckleyappalachian", "beckleyarh", "beckleyhospital", "beckleyarhhospital"), "Beckley ARH", x)
  x = ifelse(gsub(" ", "", tolower(x)) %in% c("cabell", "cabellhuntington", "cabellhuntingtonhospital"), "Cabell Huntington", ifelse(tolower(x) == "st joseph's", "St Joseph's (B)", x))
  x = ifelse(gsub("-", "", gsub(" ", "", tolower(x))) %in% c("camcteaysvalley", "camcteays", "camc-teays"), "CAMC Teays Valley", x)
  x = ifelse(gsub(" ", "", tolower(x)) %in% c("camden", "camden-clark", "camdenclark", "camden-clarkmemorialhospital"), "Camden Clark", ifelse(tolower(x) %in% c("greenbrier", "greenbrier valley medical center", "greenbriervalley"), "Greenbrier Valley", x))
  x = ifelse(gsub(" ", "", tolower(x)) %in% c("davis", "davismemorial", "davismedicalcenter", "davismemorialhospital"), "Davis Medical", x)
  x = ifelse(gsub("berkeley", "berkley", gsub(" ", "", tolower(x))) %in% c("berkleymedical"), "Berkeley Medical", x)
  x = ifelse(gsub(" ", "", tolower(x)) %in% c("camc", "charlestonarea", "charlestonareamedicalcenter"), "Charleston Area Medical Center", x)
  x = ifelse(gsub(" ", "", tolower(x)) %in% c("bluefield", "bluefieldregional", "bluefieldregionalmedicalcenter", "bluefieldregionmedicalcenter"), "Bluefield Regional", x)
  x = ifelse(tolower(x) == "camc - teays", "CAMC Teays Valley", ifelse(tolower(x) == "city", "City Hospital", x))
  x = ifelse(gsub(" ", "", tolower(x)) %in% c("fairmont", "fairmontregional", "fairmontregionalmedicalcenter", "fairmontgeneralhospital"), "Fairmont General", ifelse(tolower(x) %in% c("grant", "grant memorial hospital"), "Grant Memorial", x))
  x = ifelse(gsub(" ", "", tolower(x)) %in% c("jackson", "jacksongeneral", "wvumedicinejacksongeneralhospital", "jacksongeneralhospital"), "Jackson General", x)
  x = ifelse(gsub(" ", "", tolower(x)) %in% c("eyeandear", "eyeandearclinic", "eye&ear", "charlestonsurgical", "charlestonsurgicalhospital"), "Charleston Surgical", x)
  x = ifelse(gsub(" ", "", tolower(x)) %in% tolower(c("Logan", "LoganRegional", "LoganGeneral", "LoganRegionalMedicalCenter", "LoganGeneralHospital")), "Logan General", x)
  x = ifelse(gsub(" ", "", tolower(x)) %in% c("ohiovalley", "ovmc", "ohiovalleymedicalcenter", "ohiovalleygeneralhospital"), "Ohio Valley General", ifelse(gsub(" ", "", gsub("ommuniy", "ommunity", tolower(x))) %in% c("princetoncommunity", "princetoncommunityhospital"), "Princeton", x))
  x = ifelse(gsub(" ", "", tolower(x)) %in% c("raleigh", "raleighgeneral", "raleighgeneralhospital"), "Raleigh General", x)
  x = ifelse(gsub(" ", "", tolower(x)) %in% c("reynolds", "reynoldsmemorial", "reynoldsmemorialhospital"), "Reynolds Memorial", x)
  x = ifelse(gsub(" ", "", tolower(x)) %in% c("summersville", "summersvilleregional", "summersvillememorial", "summersvillememorialhospital"), "Summersville Memorial", x)
  x = ifelse(gsub(" ", "", tolower(x)) %in% c("monongalia", "mongeneral", "monongaliageneral", "monongaliacounty", "monongaliageneralhospital", "monhealthmedicalcenter"), "Monongalia General", x)
  x = ifelse(gsub(" ", "", tolower(x)) %in% tolower(c("Stonewall", "StonewallJackson", "MonHealthStonewallJacksonMemorialHospital", "StonewallJacksonMemorialHospital")), "Stonewall Jackson", x)
  x = ifelse(gsub(" ", "", tolower(x)) %in% tolower(c("Thomas", "ThomasMemorial", "ThomasMemorialHospital")), "Thomas Memorial", ifelse(gsub(" ", "", tolower(x)) %in% tolower(c("United", "UnitedHospital", "UnitedHospitalCenter", "UnitedHospCenter")), "United Hospital Center", x))
  x = ifelse(gsub(" ", "", tolower(x)) %in% tolower(c("Weirton", "WeirtonMedicalCenter")), "Weirton Medical", x)
  x = ifelse(gsub(" ", "", tolower(x)) %in% tolower(c("WestVirginiaUniversityHospitals", "WVUH", "WestVirginiaUniversityHospital", "WVUMedicineJ.W.RubyMemorialHospital", "wvuniv")), "WVU Hospitals", x)
  x = ifelse(gsub(" ", "", tolower(x)) %in% tolower(c("Wetzel", "WetzelCounty", "WVUWetzelCountyHospital", "WetzelCountyHospital")), "Wetzel County", ifelse(tolower(x) %in% c("wheeling", "wheeling hospital"), "Wheeling Hospital", x))
  x = ifelse(gsub(" ", "", tolower(x)) %in% tolower(c("Williamson", "WilliamsonMemorialHospital")), "Williamson Memorial", x)
  x = ifelse(gsub(" ", "", tolower(x)) == "cityhospital", "Berkeley Medical", x)
  x = ifelse(tolower(x) == "berkeley medical", "Berkeley Medical/City Hospital", x)
  x = ifelse(gsub("'", "", gsub(" ", "", tolower(x))) %in% tolower(c("StMarys", "StMary", "StMarysMedicalCenter", "stmaryshospital", "stmarymedcen")), "St Mary's", x)
  x = ifelse(gsub("'", "", gsub(" ", "", tolower(x))) %in% tolower(c("StLukes", "StLuke", "stlukesprinceton")), "St Luke's", x)
  x = ifelse(gsub("'", "", gsub(" ", "", tolower(x))) %in% tolower(c("StFranciss", "StFrancis", "StFrancisHospital", "SaintFrancisHospital")), "St Francis", x)
  x = ifelse(gsub("stjosephs", "stjoseph", gsub("'", "", gsub(" ", "", gsub(")", "", gsub("\\(", "", tolower(x)))))) %in% tolower(c("StJosephB", "StJosephBuckhannon", "stjosephhospofbuckhannon")),  "St Joseph's Buckhannon",  x)
  x = ifelse(gsub("stjosephs", "stjoseph", gsub("'", "", gsub(" ", "", gsub(")", "", gsub("\\(", "", tolower(x)))))) %in% tolower(c("StJosephP", "StJosephParkersburg")), "St Joseph's Parkersburg", x)
  x = ifelse(gsub(" ", "", tolower(x)) %in% tolower(c("PleasantValley", "PleasantValleyHospital")), "Pleasant Valley", x)
  
  #Clean WV University Hospitals 
  x = ifelse(tolower(x) %like% "wvu medicine united hospital center", "United Hospital Center", ifelse(tolower(x) %like% "wvu medicine wetzel county", "Wetzel County", x))
  x = ifelse(tolower(x) %like% "wvu medicine summersville regional", "Summersville Memorial", ifelse(tolower(x) %like% "wvu medicine st joseph's", "St Joseph's Buckhannon", x))
  x = ifelse(tolower(x) %like% "wvu medicine reynolds memorial", "Reynolds Memorial", ifelse(tolower(x) %like% "wvu medicine camden clark", "Camden Clark", x))
  x = ifelse(tolower(x) %like% "wvu medicine berkeley medical center", "Berkeley Medical/City Hospital", x)
  x = ifelse(tolower(x) %like% "wvu medicine braxton county memorial hospital", "Braxton County", x)
  x = ifelse(tolower(x) %like% "wvu medicine jefferson medical center" | tolower(x) == "jefferson", "Jefferson Memorial", x)
  x = ifelse(tolower(x) %like% "wvu medicine potomac valley hospital", "Potomac Valley", x)
  
  #Clean CAHs and other no-contract-data hospitals 
  x = ifelse(gsub(" ", "", tolower(x)) %in% c("boonememorialhospital", "boonememorial", "boonmemorial"), "Boone Memorial", x)
  x = ifelse(gsub(" ", "", tolower(x)) %in% c("braxtoncountymemorialhospital", "braxtoncounty"), "Braxton County", x)
  x = ifelse(gsub(" ", "", tolower(x)) %in% c("broaddushospassoc", "broaddushospital", "broaddus", "broaddus"), "Broaddus", x)
  x = ifelse(gsub(" ", "", tolower(x)) %in% c("graftoncityhospital", "graftoncity"), "Grafton", x)
  x = ifelse(gsub(" ", "", tolower(x)) %in% c("guyanvalleyhospital", "guyanvalley"), "Guyan Valley", x)
  x = ifelse(gsub(" ", "", tolower(x)) %in% c("hampshirememorialhospital", "hampshire"), "Hampshire Memorial", x)
  x = ifelse(gsub(" ", "", tolower(x)) %in% c("jeffersonmemorialhospital"), "Jefferson Memorial", x)
  x = ifelse(gsub(" ", "", tolower(x)) %in% c("minniehamilton", "minniehamiltonhealthcarecenter", "minniehamiltonhealthcenter", "minniehamiltonhealthsystem"), "Minnie Hamilton", x)
  x = ifelse(gsub(" ", "", tolower(x)) %in% c("montgomerygeneral", "montgomerygeneralhospital"), "Montgomery General", x)
  x = ifelse(gsub(" ", "", tolower(x)) %in% c("morgancountywarmemorial", "warmemorialhospital", "warmemorial", "morgancountywarmemorialhospital", "morgancounty"), "War Memorial", x)
  x = ifelse(gsub(" ", "", tolower(x)) %in% c("plateaumedicalcenter", "plateau"), "Plateau Medical Center", x)
  x = ifelse(gsub(" ", "", tolower(x)) %in% c("pocahontasmemorialhospital", "pocahontas"), "Pocahontas Memorial", x)
  x = ifelse(gsub(" ", "", tolower(x)) %in% c("potomacvalleyhospital", "potomacvalley"), "Potomac Valley", x)
  x = ifelse(gsub(" ", "", tolower(x)) %in% c("prestonmemorialhospital", "monhealthprestonmemorialhospital"), "Preston Memorial", x)
  x = ifelse(gsub(" ", "", tolower(x)) %in% c("richwoodareacommunityhospital", "richwood"), "Richwood Area", x)
  x = ifelse(gsub(" ", "", tolower(x)) %in% c("roanegeneral", "roanegeneralhospital"), "Roane General", x)
  x = ifelse(gsub(" ", "", tolower(x)) %in% c("sistersvillegeneralhospital"), "Sistersville General", x)
  x = ifelse(gsub(" ", "", tolower(x)) %in% c("webstercountymemorialhospital", "webster"), "Webster County", x)
  x = ifelse(gsub(" ", "", tolower(x)) %in% c("manarh", "manapparh"), "Man Appalachian", x)
  x = ifelse(gsub(" ", "", tolower(x)) %in% c("putnamgeneral", "putnamgeneralhospital"), "Putnam General", x)
  x = ifelse(gsub(" ", "", tolower(x)) %in% c("welchcommunityhospital", "welch"), "Welch Community", x)
  x = ifelse(gsub(" ", "", tolower(x)) %in% c("summerscountyarhhospital"), "Summers County ARH", x)
  #x = ifelse(gsub(" ", "", tolower(x)) %in% c("summerscountyarh"), "Summers County ARH", x)
  
  
  
  return(x)
}



cleanPayor = function(x) {
  x = gsub("-PPO", " PPO", gsub(" [Indemnity]", " Indemnity", gsub(" [PPO]", " PPO", gsub("Mt. ", "Mt ", gsub("St. ", "St ", x, fixed = T), fixed = T), fixed = T), fixed = T), fixed = T)
  x = gsub("Trad.", "Traditional", gsub("Trad ", "Traditional ", gsub("Td ", "Traditional ", x)), fixed = T)
  x = gsub(" (phys)", "-Physician", gsub(" (Lab)", "-Lab", gsub(" (SNF)", "-SNF", gsub("TRAD ", "Traditional ", x), fixed = T), fixed = T), fixed = T)
  x = gsub("Helath", "Health", gsub("SelevNet", "SelectNet", gsub("selct", "select", gsub("SElect", "Select", gsub("HOspital", "Hospital", gsub("ONesource", "One Source", x))))))
  x = gsub("WV EBS", "WVEBS", gsub("MCQ", "MCO", gsub("SElf", "Self", x)))
  #BCBS: Mountain State/Highmark BCBS (the WV BCBS)
  x = gsub("Mt State Indemnity", "Mt State Blue Cross Indemnity", gsub(" St ", " State ", gsub("Mount ", "Mountain ", x)))
  x = gsub("Mtn State", "MTST", gsub("MtStBCBS", "MTSTBCBS", gsub("Highmark", "BCBS", x)))
  x = gsub("MTSTBCBS", "BCBS", gsub("MsBCBS", "BCBS", gsub("BC and BS", "BCBS", gsub("BC/BC", "BCBS", x, fixed = T))))
  #IPN seems to be the health plan's psychologist network: http://pcasolutions.com/idd-waiver/
  x = ifelse(x == "IPN", "Health Plan IPN", x)
  x = gsub("4Most", "4 Most", gsub("4-M", "4 M", x))
  x = ifelse(toupper(x) %in% c("STRATOSE", "STRATOSE (4 MOST)", "4 MOST (STRATOSE)", "4 MOST HEALTH NETWORK"), "4 Most", x)
  x = ifelse(toupper(x) %in% c("4 MOST-DISCOUNT CHOICE"), "4 Most-Discount Choice", ifelse(toupper(x) %in% c("4 MOST (PHYSICIAN)"), "4 Most (Physician)", x))
  x = ifelse(toupper(x) %in% c("AETNA", "AETNA HEALTH", "AETNA HEALTH MANAGEMENT"), "Aetna", x)
  #Typo -- should be AMH in transcription, even if really AHM 
  x = ifelse(gsub("AHM", "AMH", toupper(x)) == "AMH --- AETNA H MGMT", "AMH", x)
  x = gsub("BCBS & BS", "BCBS", gsub("BCBS/Blue Shield", "BCBS", gsub("Blue Cross", "BCBS", gsub("Mt State", "BCBS", x)), fixed = T), fixed = T)
  x = gsub("BCBS Blue Cross", "BCBS", gsub("MSBCBS", "BCBS", gsub("BCBS BC", "BCBS", gsub("BC/BS", "BCBS", x, fixed = TRUE))))
  x = gsub("BCBSBS", "BCBS", gsub("Highmark BCBS", "BCBS", gsub("Mountain State BCBS", "BCBS", gsub("BCBS Highmark", "BCBS", x))))
  x = gsub("Anthem PPO", "Anthem-PPO", ifelse(x %in% c("Affordable Health", "Affordable/First Health"), "First Health", x))
  x = gsub("HlthAmer", "Health America", gsub("Coventry Health", "Coventry", x))
  x = gsub("CHA Tristate", "CHA (Tristate)", gsub("-Tristate", " (Tristate)", gsub("Tri-State", "Tristate", x, fixed = T), fixed = T))
  x = gsub("Choicecare", "Choice Care", gsub("ChoiceCare", "Choice Care", x))
  x = gsub("Choice Care Network", "Choice Care (Network)", gsub("Choice Care Hospital", "Choice Care (Hospital)", gsub("Choice Care Physician", "Choice Care (Physician)", x)))
  x = gsub("CIGNA", "Cigna", gsub("Behavioral Health", "Behavioral", x))
  x = ifelse(x == "Cigna PPO/POS", "Cigna-PPO/POS", x)
  x = gsub(" Psych Only", " (Psych)", gsub("Mid-Atlantic", "MidAtlantic", x))
  x = gsub("CoreSource", "Coresource", gsub("Corvel Corp", "Corvel", gsub("Corvel Corporation", "Corvel", x)))
  x = gsub("DirectCare", "Direct Care", gsub("of America", "America", gsub("america", "America", x)))
  x = ifelse(toupper(x) == "HEALTH PARTNERS NET", "Health Partners Network", ifelse(toupper(x) == "FIRST HEALTH NETWORK", "First Health", x))
  x = gsub("WVUIS/WVUIS", "WVUIS", gsub("WVUIS (formerly WVUIS Services)", "WVUIS", gsub("HPN", "WVUIS", x), fixed = T))
  x = gsub("Coaltion", "Coalition", gsub("Health coalition Partners", "Health Coalition", gsub("Health Payors Organization", "Health Payor Organization", x)))
  x = gsub("UOVPhys", "UOV (Phys", gsub("Plan UOV", "Plan of UOV", gsub("the UOV", "UOV", gsub(" Upper Ohio Valley", " UOV", x))))
  x = gsub("HealthSmart", "Healthsmart", gsub("Health Smart", "Healthsmart", x))
  x = ifelse(toupper(x) %in% c("HEALTH PLAN PAYORS ORGANIZATION, LTD.", "HEALTHSMART PAYORS ORGANIZATION"), "Healthsmart (HPO)", x)
  x = gsub("Choice Care PPO", "Choice Care (PPO", gsub("HumanaChoice", "Humana Choice", gsub("Humana/Choice", "Humana Choice", x, fixed = T)))
  x = ifelse(toupper(x) == "HUMANA BMT", "Humana (BMT)", x)
  x = ifelse(toupper(x) %in% c("INTERPLAN/DCA", "INTERPLAN HEALTH (FORMERLY DCA)", 'INTERPLAN HEALTH GROUP', "DIRECT CARE AMERICA", "DCA"), "Interplan Health", x)
  x = gsub("ALden", "Alden", gsub("Geha", "GEHA", gsub("Geisinger Health Plan", "Geisinger", x)))
  x = ifelse(toupper(x) %in% c("MDI HEALTHCARE SOLUTIONS", "MDI HEALTH CARE SOLUTIONS"), "MDI", x)
  x = gsub("Med-Select", "MedSelect", gsub("Med Select", "MedSelect", gsub("Medselect", "MedSelect", x)), fixed = T)
  x = gsub("SelectNet/Wells Fargo", "SelectNet", gsub("Selet-Net", "SelectNet", gsub("Select-Net", "SelectNet", gsub("Selectnet", "SelectNet", gsub("Select Net", "SelectNet", x)), fixed = T), fixed = T), fixed = T)
  x = gsub("Healthsmart", "HealthSmart", x)
  x = ifelse(toupper(x) == "MENTAL HEALTH ASSOC", "Mental Health Associates", ifelse(toupper(x) == "MEGALLAN HMO", "Magellan (HMO)", x))
  x = gsub("National Coalition", "National Capital", gsub("Mutiplan", "Multiplan", gsub("Communiy", "Community", gsub("Commerical", "Commercial", gsub("MH Net", "MHNET", x)))))
  x = gsub("Priate", "Private", gsub("Nationwise", "Nationwide", gsub("MultPlan", "Multiplan", gsub("Muliplan", "Multiplan", gsub("Multipla ", "Multiplan ", x)))))
  x = ifelse(toupper(x) == 'MULTI-PLAN', "Multiplan", gsub("MultiPlan", "Multiplan", x))
  x = ifelse(toupper(x) == 'MULTIPLAN BMT', "Multiplan (BMT)", ifelse(toupper(x) == "MULTIPLAN INC.", "Multiplan", x))
  x = gsub("Multiplan", "Multiplan Inc", gsub("NC PPO", "National Capital PPO", gsub("NCPPO", "National Capital PPO", x)))
  x = gsub("OneSource", "One Source", gsub("Onesource", "One Source", gsub("Optima Commercial", "Optimal Commercial", x)))
  x = gsub("Partcipation", "Participation", gsub("PPO USA", "PPOUSA", x))
  x = ifelse(toupper(x) == "PRIMARY HEALTH SERVICES", "Primary Health", x)
  x = gsub("of West Virginia", "of WV", gsub("HC Systems", "Healthcare Systems", x))
  x = gsub("Prov Netwk", "Provider Network", gsub("The HealthPlan", "The Health Plan", gsub("Med. Ctr.", "Med Ctr", x, fixed = T)))
  x = gsub("United Health Care", "United Healthcare", gsub("United healthcare", "United Healthcare", gsub("United healthcare", "United Healthcare", x)))
  x = gsub("OptimumCho", "Optimum Choice", gsub("OPtimum", "Optimum", gsub("United HealthCare", "United Healthcare", x)))
  x = ifelse(toupper(x) %in% c("OPTIMUM CHOICE", "UNITED HEALTHCARE-FORMERLY OPTIMUM CHO", "UNITED HEALTHCARE (OPTIMUM CHOICEICE)", 'OPTIMUM CHOICE (MAMSI)'), "United Healthcare AKA Optimum Choice", x)
  x = gsub("United Healthcare/Optimum Choice", "United Healthcare", x, fixed = T)
  x = gsub("United Payers", "United Payors", ifelse(toupper(x) == "UNITED PAYER", "United Payers", x))
  #UP & UP is a middleman that bought other middlemen (https://www.washingtonpost.com/archive/business/1998/04/27/94-united-payors-united-providers-inc/39655347-ca25-434b-9717-2f4daaa08cca/) 
  # And then was purchased by BCE Emergis (https://www.theglobeandmail.com/report-on-business/united-payors-approves-bce-emergis-takeover/article22402653/)
  # And then was sold to Multiplan (https://www.nytimes.com/2004/01/03/business/company-news-bce-emergis-is-selling-health-unit-to-multiplan.html)
  x = ifelse(toupper(x) %in% c("UNITED PAYORS & PROV", "UNITED PAYORS & UNITED PROVIDERS", "UNITED PAYORS & PROVIDERS"), "United Payors and Providers", x)
  x = ifelse(toupper(gsub(" ", "", gsub(".", "", x, fixed = T), fixed = T)) == "UNITEDETAL", "United", x)
  x = gsub("Wal-Mart", "Walmart", x, fixed = T)
  x = gsub("The Health", "Health", gsub("Flora Prepared", "Flora Preferred", x))
  x = gsub("Valley Hospice, Inc.", "Valley Hospice", gsub("Healthsouth", "HealthSouth", x), fixed = T)
  x = ifelse(x %in% c("UP & UP", "UP UP"), "United Payors and Providers", x)
  x = ifelse(x == "Corvel.", "Corvel", ifelse(x == "Common wealth", "Commonwealth", x)) 
  x = ifelse(gsub("Heath", "Health", x) == "Health Plan", "Health Plan UOV", ifelse(x== "Health Plan (Physician)", "Health Plan UOV (Physician)", x))
  x = ifelse(x == "ASC-Flora Health Network", "ASC Flora", ifelse(x == "BCBS OP Lab", "BCBS OP (Lab)", x)) 
  x = gsub("CCN-One", "CCN/One", gsub("Accordia National HealthSmart", "Accordia National Select", gsub("MOST", "Most", x)), fixed = T)
  x = ifelse(x == "Intergrated Health", "Integrated Health Network", gsub("Inter Group", "Intergroup", gsub("Integroup", "Intergroup", x)))
  x = gsub("Magellan HMO", "Magellan (HMO", gsub("MSMI", "MAMSI", gsub("Mamsi", "MAMSI", gsub("Mental Hlth Phys", "Mental Health Phys", x))))
  x = ifelse(x == "One Source Health", "One Source Health Network", x)
  x = gsub("Pipetrades", "Pipestrades", gsub("Private Health Care", "Private Healthcare", gsub("Private Lth", "Private Health", x))) 
  x = gsub("Self-Funded", "Self Funded", gsub("Rite-Aid", "RiteAid", gsub("Private Healthcare Systems", "Private Healthcare System", x), fixed = T), fixed = T)
  x = ifelse(tolower(x) %like% "western hills", "Western Hills", ifelse(x == "Accordia National SelectNet", "Accordia National Select", x))
  x = ifelse(x == "United Healthcare", "United", ifelse(x == "MedSelect", "HealthSmart (MedSelect)", x))
  #A subsidiary of multiplan (https://www.multiplan.com/pdf/providers/howtowork/MultiPlanNetworkProfessional%20Handbook_7-31-2015.pdf)
  x = gsub("PHCS", "Private Healthcare Systems", x)
  x = gsub("Private Healthcare Systems", "Private Healthcare Systems (MultiPlan)", x)
  #N.b., Flora became Aetna Cofinity (http://www.aetna.com/producer/aetnalink/2007-11/4qlink_MM_cofinity.html) 
  #N.b., in 2015 Aetna acquired Coventry/Carelink 
  
  #Totals
  x = ifelse(substr(tolower(x), 1, 5) == "total", "Total", x)
  x = ifelse(substr(tolower(x), 1, 5) == "other", "Other", x)
  
  #Clean up BCBS names 
  x = ifelse(
    x %like% "BCBS", 
    ifelse(
      x %like% "MD", 
      "MD BCBS",
      gsub("Standard", "Indemnity", gsub("Traditional", "Indemnity", gsub("Non PPO", "Indemnity", x)))),
    x
    )
  x = gsub("BCBSSkilled", "BCBS-Skilled", gsub("MTST BCBS", "BCBS", x))
  x = ifelse(x == "BCBS (Mountain State)" | x == "BCBS West Virginia Inc." | x == "Mtn. State BlueCross/BlueShield, Inc." | x == "BCBS West Virginia, Inc." | x == "BCBS Blue Shield, Inc.", "BCBS", x)
  x = ifelse(x %like% "BCBS" & stringr::str_sub(x, -4, -1) == " PPO", gsub(" PPO", "-PPO", x, fixed = T), x)
  x = gsub(" (PPO)", "-PPO", gsub(" (Indemnity)", "-Indemnity", x, fixed = T), fixed = T)
  
  #Some typos
  x = gsub("physician", "Physician", gsub("Physiciain", "Physician", gsub("Psych Only", "(Psych)", x)))
  x = gsub("Med-Surg", "Med Surg", gsub("-SNU", " (SNU)", gsub("-SNF", " (SNF", gsub("-Lab", " (Lab", gsub("Physicians", "Physician", x), fixed = T), fixed = T), fixed = T), fixed = T)
  x = gsub("HlthAssur", "Health Assurance", gsub("Hlth Assur", "Health Assurance", gsub("Hlth Amer", "Health America", gsub("U.S.", "US", x, fixed = T), fixed = T)))
  x = gsub("teamsters", "Teamsters", gsub("Paayors", "Payors", gsub("Choice care", "Choice Care", x))) 
  x = ifelse(tolower(x) == "florence critten", "Florence Crittenton", x)
  x = ifelse(tolower(x) %in% c("humana choice care ppo", "humana choice care (ppo)"), "Humana Choice Care-PPO", x)
  
  #Multiple insurance types. Dash for PPO/HMO/etc., parentheses for physician/pro. fees/etc.
  x = gsub("- ", "-", gsub(" -", "-", gsub(" - ", "", x, fixed = T), fixed = T), fixed = T)
  x = gsub("BCBSPPO", "BCBS-PPO", gsub("BCBSHome", "BCBS-Home", gsub("BCBSPhys", "BCBS-Phys", gsub("BCBSTrad", "BCBS-Trad", gsub("BCBSWheel", "BCBS-Wheel", x)))))
  x = gsub("BCBS PPO", "BCBS-PPO", gsub(" & PPO", "/PPO", x, fixed = TRUE))
  x = gsub("BCBSIndemnity", "BCBS-Indemnity", gsub(" Indemnity", "-Indemnity", gsub("Ind/", "Indemnity/", gsub(" (Indemnity/PPO)", "-Indemnity/PPO", x, fixed = T), fixed = T)))
  x = gsub("-Pro. Fees", " (Pro. Fees", gsub("-Physician", " (Physician", x, fixed = T), fixed =  T)
  x = gsub("UOVPhys", "UOV (Phys", x)
  x = gsub("Opt only", " (Outpatient)", x)
  x = gsub("-Home Health", " (Home Health)", x, fixed = T)
  x = gsub("--", "-", gsub("Physician", "Phys", x), fixed = T)
  x = ifelse(x == "BCBSSkilled", "BCBS-Skilled", x)
  x = ifelse(x == "American Health Services", "American Health Service", ifelse(x == "Teamster", "Teamsters", x))
  x = ifelse(x %in% c("Multiplan Inc", "Multiplan Inc Inc", "Multiplan Inc, Inc.", "Multiplan Inc, INc."), "Multiplan", x)
  x = gsub("Gneral", "General", gsub("CignaConnecticut General", "Cigna-Connecticut General", x))
  x = gsub("Healthare", "Healthcare", gsub("CIgna", "Cigna", gsub("BCBSSteel", "BCBS-Steel", gsub("BCBStraditional", "BCBS-Traditional", x))))
  x = gsub("PReferred", "Preferred", gsub("American Halth", "American Health", gsub("Unite Payors", "United Payors", gsub("Ciy ", "City ", gsub("COMM MT", "COM MT", x)))))
  x = gsub("health Plan", "Health Plan", gsub("PArtners", "Partners", gsub("Indemniy", "Indemnity", gsub("Cntral", "Central", gsub("Phsician", "Phys", x))))) 
  
  #Remaining typos
  x = ifelse(x == "Admin W/O", "Administrative Write-Offs", ifelse(x == "IPNHealth Plan", "Health Plan IPN", x))
  
  #Make sure parentheses line up 
  x = ifelse(x %like% "\\(" & !x %like% "\\)", paste0(x, ")"), x)
  x = gsub("((", "(", gsub("))", ")", x, fixed = T), fixed = T)
  
  #Insurance market reports
  x = gsub("and", "\\&", x)
  x = gsub("Ins Company", "Ins Co", gsub("Insurance Co", "Ins Co", gsub(", Inc\\.", "", gsub("Ins\\.", "Ins", gsub("Co\\.", "Co", x)))))
  x = ifelse(x %like% "Hlth Plan Upper OH Valley" | x %like% "Health Plan of UOV" | x %like% "Health Plan of the UOV" | x == "Health Plan of the Upper OH Val.", ifelse(gsub(" ", "", toupper(x)) %like% "UOVPHYS" | gsub(" ", "", toupper(x)) %like% "UOV\\(PHYS", "HPUOV-Physician", ifelse(toupper(x) %like% "RMH", "RMH HPUOV", "HPUOV")), x)
  x = ifelse(x == "THP Ins Co" | x == "THP", "The Health Plan", ifelse(x %like% "Golden Rule", "Golden Rule", x))
  x = ifelse(x == "Coventry Hlth & Life Ins Co (Aetna Post-2015)" | x == "Coventry & Life Ins Co", "Coventry H&L (Aetna Post-2015)", x)
  x = ifelse(x %like% "Carelink Hlth Plans Inc/Coventry", "Carelink (Aetna Post-2015)", x)
  x = ifelse(x == "United Healthcare Ins Co", "United Healthcare", x)
  x = ifelse(substr(x, nchar(x) - 6, nchar(x)) == " Ins Co", substr(x, 1, nchar(x) - 7), x)
  
  #Sorting within dashes, parentheses TODO 
  
  return(x)
}

payorToMCO = function(x) {
  
  payorToMCO = x
  
  #4 Most
  MCO = ifelse(x %like% "4 Most" |x %like% "4Most", "4 Most", x)
  
  #United contracts
  MCO = ifelse(!(x %like% "Optimum Choice") | (x %like% "Optimus Choice") & ((x %like% "United") | (toupper(x) %like% "UHC") | (x == "Unite Payors")), "United", MCO)
  #Owned by United at least by 2010, so reading as same network 
  MCO = ifelse((x %like% "Optimum Choice") | (x %like% "Optimus Choice"), "United", x)
  
  #Aetna
  MCO = ifelse(x %like% "Aetna", "Aetna", MCO)
  
  #Carelink generally 
  MCO = ifelse(
    tolower(x) %like% "carelink" | tolower(x) %like% "health america" | tolower(x) %like% "health assurance" | tolower(x) %like% "coventry" | tolower(x) %like% "primeone",
    ifelse(x == "Coventry Transplant Network", MCO, "Carelink/Coventry"),
    MCO
  )
  
  #Weirdness with CCN vs One Source vs Mednet --- assuming all the same
  MCO = ifelse(tolower(x) %like% "ccn" | tolower(x) %like% "one source" | tolower(x) %like% "mednet", "One Source", MCO)
  
  #TODO: What to do about CHA?
  
  #Assorted networks
  MCO = ifelse((x %like% "Accordia" | x %like% "Acordia") & !(x %like% "BRMC"), "Accordia/Meritain", MCO)
  MCO = ifelse(x %like% "BRMC" | x %like% "Meritain", "Accordia/Meritain", MCO)
  MCO = ifelse(x %like% "Private Healthare" | tolower(x) %like% "private healthcare" | tolower(x) %like% "private hlth care", "PHCS (owned by Multiplan)", MCO)
  MCO = ifelse(tolower(x) %like% "mhnet", "MHNET", MCO)
  #Healthsmart owns selectnet and interplan but the networks are different: https://www.healthsmart.com/PDFs/HS-Provider-Manual-2015-v9-02-02-2016.pdf 
  #MCO = ifelse(tolower(x) %like% "healthsmart" | tolower(x) %like% "medselect" | tolower(x) %like% "interplan" | tolower(x) %like% "dca", "healthsmart", MCO)
  MCO = ifelse(tolower(x) %in% c("healthsmart", "healthsmart (hpo)", "healthsmart payors"), "HealthSmart", MCO)
  MCO = ifelse(tolower(x) %in% c("usa", "usa-mco", "usa-mcq", "usa managed care"), "USA MCO", MCO)
  MCO = ifelse(tolower(x) %like% "administrative write-offs", "Administrative Write-Offs", MCO)
  MCO = ifelse(tolower(x) %like% "advantage health", "Advantage Health", MCO)
  MCO = ifelse(tolower(x) %like% "america's hp" | tolower(x) %like% "america's health plan", "America's Health Plan", MCO)
  MCO = ifelse(gsub("halth", "health", gsub("services", "service", tolower(x))) == "american health service", "American Health Service", MCO)
  MCO = ifelse(tolower(x) %in% c("ahm", "amh"), "AMH", MCO)
  MCO = ifelse(tolower(x) %like% "anthem", "Anthem", MCO)
  MCO = ifelse(tolower(x) %like% "flora" | tolower(x) %like% "floria", "Flora/Cofinity", MCO)
  MCO = ifelse(tolower(x) %like% "breast care awareness", "Breast Care Awareness", MCO)
  #Humana acquired choicecare in 1997: https://mergr.com/humana-acquires-choicecare
  MCO = ifelse(tolower(x) %like% "choice care" | tolower(x) %like% "humana", "Humana", MCO)
  MCO = ifelse(x %like% "CHP", "CHP", MCO)
  MCO = ifelse(gsub("ciy", "city", tolower(x)) == "city of huntington", "City of Huntington", MCO)
  MCO = ifelse(gsub('cntral', 'central', tolower(x)) == 'central benefits', 'Central Benefits', MCO)
  MCO = ifelse(tolower(x) %in% c("com mt", "comm mt"), "COMM MT", MCO)
  MCO = ifelse(tolower(x) %like% "commonwealth" | x %like% "CHA", "CHA", MCO)
  MCO = ifelse(tolower(gsub("&", "and", x, fixed = T)) %like% "chandler group", "Chandler Group", MCO)
  MCO = ifelse(tolower(x) %like% "concentra", "Concentra Preferred Systems", MCO)
  MCO = ifelse(tolower(x) %like% "fedmed", "FedMed", MCO)
  MCO = ifelse(tolower(x) %like% "first ohio", "First Ohio Preferred", MCO)
  MCO = ifelse(tolower(x) %like% "florence critten", "Florence Crittenton", MCO)
  MCO = ifelse(tolower(x) %like% "geha" | tolower(x) %like% "ppousa" | tolower(x) %like% "pro usa", "GEHA", MCO)
  MCO = ifelse(tolower(x) %like% "health coalition" | tolower(x) %like% "intergroup", "Health Coalition", MCO)
  MCO = ifelse(x %like% "PN"  & (tolower(x) %like% "health plan" | tolower(x) %like% "hpi"), "IPN", MCO)
  MCO = ifelse(x %like% "UOV" & (tolower(x) %like% "health plan" | tolower(x) %like% "hpu"), "HPUOV", MCO)
  MCO = ifelse(tolower(x) == "firsthealth", "First Health", MCO)
  #Based on https://www.healthplan.org/about-us/strategic-partners and 
  # HPUOV considering Raleigh General in-network for commercial HMO currently, 
  # despite only possible contract I can find being through First Health
  MCO = ifelse(tolower(MCO) == "first health", "HPUOV", MCO)
  MCO = ifelse(tolower(x) %like% "john alden", "John Alden Life Insurance", MCO)
  MCO = ifelse(tolower(x) %like% "lba", "LBA Health", MCO)
  MCO = ifelse(tolower(x) %like% "magellan", "Magellan", MCO)
  #Possibly the same as mid-atlantic? But I think not based on it being United subsidiary not Cigna
  MCO = ifelse(tolower(x) %like% "mamsi" & !tolower(MCO) %like% "united", "MAMSI", MCO)
  MCO = ifelse(tolower(x) %like% "mamsi" &  tolower(MCO) %like% "united" & !tolower(x) %like% "onenet", "United", MCO)
  MCO = ifelse(tolower(x) %in% c("med mutual", "medical benefits"), "Medical Benefits Mutual Life", MCO)
  MCO = ifelse(tolower(x) %like% "mental" & tolower(x) %like% "network", "Mental Health Network", MCO)
  MCO = ifelse(tolower(x) %like% "occunet", "OccuNet", MCO)
  MCO = ifelse(tolower(x) %like% "primary" & (tolower(x) %like% "health" | tolower(x) %like% "hlth") & MCO != "Multiplan", "PHCS (owned by Multiplan)", MCO)
  MCO = ifelse(tolower(x) %like% "prime care", "Prime Care", MCO)
  #Should this be part of healthsmart? I think not 
  MCO = ifelse(MCO == x & tolower(MCO) %like% "selectnet", "SelectNet", MCO)
  MCO = ifelse(tolower(x) %like% "three rivers" | x == "TRPN", "Three Rivers", MCO)
  MCO = ifelse(x %like% "MDI", "MDI", MCO)
  MCO = ifelse(tolower(x) %like% "upmc", "UPMC", MCO)
  MCO = ifelse(tolower(x) %like% "western hills", "Western Hills", MCO)
  MCO = ifelse(tolower(x) %like% "united payors", "United Payors & Providers", MCO)
  MCO = ifelse(tolower(x) == "united healthcare", "United", MCO)
  
  #Geisinger WVUIS != WVUIS, I've decided based on Berkeley Medical
  MCO = ifelse(tolower(x) %like% "geisinger", "Geisinger", ifelse(tolower(x) %like% "wvuis", "WVUIS", MCO))
  
  #Cigna operates for some other payors 
  MCO = ifelse(tolower(x) %like% "connecticut g", "Connecticut General", ifelse(tolower(x) %like% "echostar", "Echostar", ifelse(tolower(x) %like% 'cigna', 'Cigna', MCO)))
  
  #4 Most IHN != IHN, I think
  MCO = ifelse(tolower(x) %like% "4", MCO, ifelse(tolower(x) %like% "integrated health" | x %like% "IHN", "IHN", MCO))
  
  #BCBS Contracts 
  MCO = ifelse(
    x %like% "BCBS",
    ifelse(
      x %like% "Steel" | x %like% "Wheeling",
      "BCBS-WP Steel",
      ifelse(
        x %like% "MD", 
        "MD BCBS",
        "BCBS"
      )
    ),
    MCO
  )
  
  MCO = ifelse(toupper(trimws(MCO)) %in% c("UHC", "UHC HOSPITAL"), "United", MCO)
  
  
  return(MCO)
}

